<?php
// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) die;

function bp_aus_lite_screentabs_advanced_search($displayOptions){
	global $field;
	global $bp;
	global $wpdb;

	$searchTypeOptions = bp_aus_lite_settings_options();
	$alreadySet = get_option('bp_aus_lite_settings');
	$txt = '';
	$txt .= bp_aus_lite_screentabs_functions_form_header(
			'',
			array('id' => 'bp_aus_lite_form', 'name' => 'bp_aus_lite_form'),
			array('action' => 'search', 'search-type' => 'advanced'),
			'bp-aus-form',
			true,
			'advanced'
	);
	//$avtualStype = !empty($_SESSION['bp_advanced_user_search']['search_type']) ? $_SESSION['bp_advanced_user_search']['search_type'] : $alreadySet['default_advanced_search_type'];
	$txt .= bp_aus_lite_screentabs_settings_get_buttons('Advanced Search', 'Reset Search Form', 0);
	$counter = 1;
	$txt .= bp_aus_lite_screentabs_functions_form_row('bp_aus_lite_search_display', 'On Screen', 'selectbox', false, 'Display Results', $displayOptions, $counter, '', false);

	// CUSTOM - Group Search Filter
	$bp_groups = $wpdb->get_results('SELECT * FROM wp_bp_groups');
	$groupsFilterOptions = array(
		''	=> 'None'
	);

	foreach ($bp_groups as $bp_group) {
		$groupsFilterOptions[$bp_group->id] = $bp_group->name;
	}

	$counter++;

	if (isset($_SESSION['bp_advanced_user_search']['detailed']['bp_aus_lite_search_group']) && is_numeric($_SESSION['bp_advanced_user_search']['detailed']['bp_aus_lite_search_group'])){
		$fieldValue = $_SESSION['bp_advanced_user_search']['detailed']['bp_aus_lite_search_group'];
	} else{
		$fieldValue = '';
	}

	$txt .= bp_aus_lite_screentabs_functions_form_row('bp_aus_lite_search_group', $fieldValue, 'idselectbox', false, 'Groups Filter', $groupsFilterOptions , $counter, '', false);

	$RangeFields = array();
	for($rangeCnt = 1; $rangeCnt <= BP_AUS_MAX_RANGE_FIELDS; $rangeCnt++){//var_dump($alreadySet['range'.$rangeCnt]); echo "<br>";
		if(!empty($alreadySet['range'.$rangeCnt])) array_push($RangeFields, $alreadySet['range'.$rangeCnt]);
	}

	$MultiFields = array();
	for($multiCnt = 1; $multiCnt <= BP_AUS_MAX_MULTI_FIELDS; $multiCnt++){//var_dump($alreadySet['multi'.$multiCnt]); echo "<br>";
		if(!empty($alreadySet['multi'.$multiCnt])) array_push($MultiFields, $alreadySet['multi'.$multiCnt]);
	}
	//$totalGroups = sizeof(bp_profile_groups());echo $totalGroups; die;
	if (bp_has_profile('hide_empty_fields=0')) while (bp_profile_groups()){
		// Advance the pointer
		bp_the_profile_group();

		$counter++;
		$txt .= bp_aus_lite_screentabs_functions_form_row('' , '', 'empty', false, '', $counter);
		$counter++;
		$txt .= bp_aus_lite_screentabs_functions_form_row(str_replace('-', '_', bp_get_the_profile_group_slug()), '', 'empty', false, bp_get_the_profile_group_name(), $counter);

		while (bp_profile_fields()){
			// Advance the pointer
			bp_the_profile_field();

			if (isset($alreadySet['showed_form_fields']) && ((is_array($alreadySet['showed_form_fields']) && !in_array($field->id, $alreadySet['showed_form_fields'])) || $alreadySet['showed_form_fields'] !== "all")){
				continue;
			}

			$counter++;
			$fieldName = 'field_'. $field->id;
			if (!method_exists($field, 'get_children')){
				$field = new BP_XProfile_Field($field->id);
			}
			$options = $field->get_children();

			if(in_array($field->id, $RangeFields)){
				$fieldValue = array(
					'type' => 'single',
					'range1' => '',
					'range2' => ''
				);

				//type
				if(isset($_POST['field_'. $field->id .'_range_opt']) && $_POST['field_'. $field->id .'_range_opt'] != ''){
					$fieldValue['type'] = $_POST['field_'. $field->id .'_range_opt'];
				}
				elseif(isset($_SESSION['bp_advanced_user_search']['detailed']['field_'. $field->id .'_range_opt']) && $_SESSION['bp_advanced_user_search']['detailed']['field_'. $field->id .'_range_opt'] != ''){
					$fieldValue['type'] = $_SESSION['bp_advanced_user_search']['detailed']['field_'. $field->id .'_range_opt'];
				}

				//range1
				if(isset($_POST['field_'. $field->id .'_range1']) && $_POST['field_'. $field->id .'_range1'] != ''){
					$fieldValue['range1'] = $_POST['field_'. $field->id .'_range1'];
				}
				elseif(isset($_SESSION['bp_advanced_user_search']['detailed']['field_'. $field->id .'_range1']) && $_SESSION['bp_advanced_user_search']['detailed']['field_'. $field->id .'_range1'] != ''){
					$fieldValue['range1'] = $_SESSION['bp_advanced_user_search']['detailed']['field_'. $field->id .'_range1'];
				}

				//range2
				if(isset($_POST['field_'. $field->id .'_range2']) && $_POST['field_'. $field->id .'_range2'] != ''){
					$fieldValue['range2'] = $_POST['field_'. $field->id .'_range2'];
				}
				elseif(isset($_SESSION['bp_advanced_user_search']['detailed']['field_'. $field->id .'_range2']) && $_SESSION['bp_advanced_user_search']['detailed']['field_'. $field->id .'_range2'] != ''){
					$fieldValue['range2'] = $_SESSION['bp_advanced_user_search']['detailed']['field_'. $field->id .'_range2'];
				}
			} elseif(in_array($field->id, $MultiFields)){
				$fieldValue = '';
				$txt .= '<div class="bpaus-multifield-container" data-name="' . $fieldName . '">';
				if (isset($_SESSION['bp_advanced_user_search']['detailed'][$field->id]) && is_array($_SESSION['bp_advanced_user_search']['detailed'][$field->id]) && !empty($_SESSION['bp_advanced_user_search']['detailed'][$field->id])){
					foreach ($_SESSION['bp_advanced_user_search']['detailed'][$field->id] as $value){
						$fieldValue = trim($value);

						$txt .= bp_aus_lite_screentabs_functions_form_row($fieldName . '[]', $fieldValue, $field->type , false, $field->name, $options, $counter, '', 1 , 0, false);
					}
				} else{
					if (isset($_SESSION['bp_advanced_user_search']['detailed'][$field->id]) && !is_array($_SESSION['bp_advanced_user_search']['detailed'][$field->id]) && $_SESSION['bp_advanced_user_search']['detailed'][$field->id] !== ''){
						$fieldValue = $_SESSION['bp_advanced_user_search']['detailed'][$field->id];
					}

					$txt .= bp_aus_lite_screentabs_functions_form_row($fieldName . '[]', $fieldValue, $field->type , false, $field->name, $options, $counter, '', 1 , 0, false);
				}
				$txt .= '</div>';
			} else{
				$fieldValue = '';
				if(isset($_SESSION['bp_advanced_user_search']['detailed'][$field->id]) && !is_array($_SESSION['bp_advanced_user_search']['detailed'][$field->id]) && $_SESSION['bp_advanced_user_search']['detailed'][$field->id] !== ''){
					$fieldValue = $_SESSION['bp_advanced_user_search']['detailed'][$field->id];
				} elseif(!empty($_SESSION['bp_advanced_user_search']['detailed'][$field->id])) {
					$fieldValue = $_SESSION['bp_advanced_user_search']['detailed'][$field->id];
				}
			}

			if(!in_array($field->id, $MultiFields)){
				$txt .= bp_aus_lite_screentabs_functions_form_row( $fieldName, $fieldValue, $field->type , false, $field->name, $options, $counter, '', 1 , 0, (in_array($field->id, $RangeFields)));
			}
		}
	}

	$txt .= bp_aus_lite_screentabs_settings_get_buttons('Advanced Search','Reset Search Form');
	$txt .= bp_aus_lite_screentabs_functions_upgrade_info();

	echo $txt;
}
?>
