<?php
///to do -> use global value as an option value, set them at the start ......

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) die;

function bp_aus_lite_admin_menu() {
	if (isset($_POST['action'])){
		if($_POST['action'] == 'search') add_users_page('BP-AUS Lite', 'BP-AUS Lite', 'list_users','BP-AUS-Lite', 'bp_aus_lite_search_results');
		elseif($_POST['action'] == 'bp_aus_lite_setup') add_users_page('BP-AUS Lite', 'BP-AUS Lite', 'manage_options','BP-AUS-Lite', 'bp_aus_lite_screentabs_settings_update');
	}
	else{
		if(isset($_GET['action'])){
			if($_GET['action'] == 'search') add_users_page('BP-AUS Lite', 'BP-AUS Lite', 'list_users','BP-AUS-Lite', 'bp_aus_lite_search_results');
		}
		else add_users_page('BP-AUS Lite', 'BP-AUS Lite', 'list_users','BP-AUS-Lite', 'bp_aus_lite_html_tab_switcher');
	}
}


function bp_aus_lite_activate(){
	register_setting( 'bp_aus_lite_settings_group', 'bp_aus_lite_settings' );
	$optValue = array(
		'max_results_on_page' => 20,
		'showed_fields' => 'all',
		'showed_form_fields' => 'all',
		'search_options' => 'LIKE %searched value%',
		'search_type_checkbox' => 'OR',
		'display_user_mail' => false
	);
	for($rangeCnt = 1; $rangeCnt <= BP_AUS_MAX_RANGE_FIELDS; $rangeCnt++){
		$optValue['range'.$rangeCnt] = '';
	}
	for($multiCnt = 1; $multiCnt <= BP_AUS_MAX_MULTI_FIELDS; $multiCnt++){
		$optValue['multi'.$multiCnt] = '';
	}
	for($orCnt = 1; $orCnt <= BP_AUS_MAX_OR_GROUPS; $orCnt++){
		$optValue['or'.$orCnt] = array();
	}
	if (get_option('bp_aus_lite_settings') === false){
		add_option( 'bp_aus_lite_settings', $optValue, '', 'yes');
	} else{
		$options = get_option('bp_aus_lite_settings');
		$options_to_store = array_merge($optValue, $options);

		update_option( 'bp_aus_lite_settings', $options_to_store, 'yes');
	}

	/*
	if(!file_exists(TEMPLATEPATH.'/template-bp-aus-member-search.php')){
		copy(plugins_url( '/extras/template-bp-aus-member-search.php', __FILE__ ),TEMPLATEPATH.'/template-bp-aus-member-search.php');
	}
	if(!file_exists(TEMPLATEPATH.'/includes/loop-bp-aus-member-search.php')){
		copy(plugins_url( '/extras/loop-bp-aus-member-search.php', __FILE__ ),TEMPLATEPATH.'/includes/loop-bp-aus-member-search.php');
	}
	*/

	return true;
}

function bp_aus_lite_dectivate(){
	//remove options field
	//delete_option('bp_aus_lite_settings');
	//delete_option('bp_aus_lite_plugin_version');

	/*
	if(file_exists(TEMPLATEPATH.'/template-bp-aus-member-search.php')) unlink(TEMPLATEPATH.'/template-bp-aus-member-search.php');
	if(file_exists(TEMPLATEPATH.'/includes/loop-bp-aus-member-search.php')) unlink(TEMPLATEPATH.'/includes/loop-bp-aus-member-search.php');
	*/
}

function bp_aus_lite_admin_load_js_and_css($hook){
	if ($hook != "users_page_BP-AUS-Lite"){
        return;
    }

	wp_register_style('bp_aus_lite_forms_styles',plugins_url( '/css/admin-style.css', __FILE__ ),array(),BP_AUS_PLUGIN_VERSION,'all');
	wp_enqueue_style( 'bp_aus_lite_forms_styles');

	wp_register_script('bp_aus_lite_main_scripts',plugins_url( '/js/script.js', __FILE__ ),array( 'jquery','jquery-form'),BP_AUS_PLUGIN_VERSION,true);
	wp_enqueue_script('bp_aus_lite_main_scripts');
}

function bp_aus_lite_load_js(){
	wp_register_script('bp_aus_lite_main_scripts',plugins_url( '/js/script.js', __FILE__ ),array( 'jquery','jquery-form'),BP_AUS_PLUGIN_VERSION,true);
	wp_enqueue_script('bp_aus_lite_main_scripts');
}

function bp_aus_lite_admin_init(){
	if(current_user_can('list_users')){
		$ResultBack = array();
		$sitename = sanitize_key( get_bloginfo( 'name' ) );
		if ( ! empty( $sitename ) ) $sitename .= '.';
		$filename = $sitename . 'users.' . date( 'Y-m-d-H-i-s' ) . '.csv';
		header( 'Content-Description: File Transfer' );
		header( 'Content-Disposition: attachment; filename=' . $filename );
		header( 'Content-Type: text/csv; charset=' . get_option( 'blog_charset' ), true );

		if(isset($_POST['search-type']) and $_POST['search-type'] == 'fast') $ResultBack = bp_aus_lite_sql_fast_search();
		else $ResultBack = bp_aus_lite_sql_detailed_search();
		die;
	}
}

function bp_aus_lite_search_results(){
	$maxSearchResults = 5;
	$ResultBack = array();
	if(current_user_can('list_users') ){
		if(isset($_POST['action']) and $_POST['action'] == 'search'){
			if(isset($_POST['search-type'])){
				if($_POST['search-type'] == 'fast') $ResultBack = bp_aus_lite_sql_fast_search($maxSearchResults);
				elseif($_POST['search-type'] == 'advanced') $ResultBack = bp_aus_lite_sql_detailed_search($maxSearchResults);
			}
		}
		else{
			if(isset($_SESSION['bp_advanced_user_search'])){
				if($_SESSION['bp_advanced_user_search']['mode'] == 'fast') $ResultBack = bp_aus_lite_sql_fast_search($maxSearchResults);
				elseif($_SESSION['bp_advanced_user_search']['mode'] == 'advanced') $ResultBack = bp_aus_lite_sql_detailed_search($maxSearchResults);
			}
		}

		if(isset($ResultBack['error'])) bp_aus_lite_html_errormsg($ResultBack['error']);
		else{
			bp_aus_lite_html_paginations( $ResultBack['max'], $ResultBack['found'] , 'top');
			bp_aus_lite_html_show($ResultBack['result'], $ResultBack['max']);
			bp_aus_lite_html_paginations( $ResultBack['max'], $ResultBack['found'] );
		}
	}
	else bp_aus_lite_html_errormsg('You do not have permissions to list users. Please contact administrator');
}

function bp_aus_lite_users_search_button(){
	$screen = get_current_screen();

	if ($screen->id !== "users"){
		return;
	}

	?>
	<script type="text/javascript">
	jQuery(document).ready(function ($){
		$('.search-box').append('<a class="button-primary" href="users.php?page=BP-AUS-Lite&tab=advanced" title="Buddypress Advanced User Search" style="margin-left: 10px;">Go to Advanced Search</a>');
	});
	</script>
	<?php
}

function bp_aus_lite_check_version(){
	if ($noOption = (get_option('bp_aus_lite_plugin_version') === false) || BP_AUS_PLUGIN_VERSION > get_option('bp_aus_lite_plugin_version')){
		bp_aus_lite_activate();

		if ($noOption){
			add_option('bp_aus_lite_plugin_version', BP_AUS_PLUGIN_VERSION);
		} else{
			update_option('bp_aus_lite_plugin_version', BP_AUS_PLUGIN_VERSION);
		}
	}
}

function bp_aus_lite_register_session(){
	$session_id = session_id();

	if (empty($session_id)){
		session_start();
	}
}
?>
