function clear_form_elements(ele) {
	jQuery(ele).find(":input").each(function() {
		var valArr = ["password","select-multiple","select-one","text","textarea"];
		if(jQuery.inArray(this.type, valArr) >= 0 ? jQuery(this).val("") : this.checked = false );
	});
	jQuery(ele).find("a.bpaus_select_all").each(function(){
		jQuery(this).attr("data-mode","0");
		jQuery(this).text("Select All");
	});
	if(jQuery('#bp_aus_search_type') != undefined){
		jQuery('#bp_aus_search_type').trigger('change');
	}
}
function reset_default_css(ele) {
	jQuery.get('../wp-content/plugins/bp-advanced-user-search/css/client-style-template.css', function (data){
	    ele.innerHTML = data;
	});
}
jQuery(document).ready(function($) {
	jQuery(document).find("a.bpaus_select_all").each(function() {
		jQuery(this).click(function(e){
			e.preventDefault();
			var parent = jQuery(this).parent();
			var select = parent.find("select");
			var chkbox = parent.find("input[type=checkbox]");
			var status = jQuery(this).attr("data-mode");
			var new_status = false;
			if(status == "0"){
				new_status = true;
				jQuery(this).attr("data-mode","1");
				jQuery(this).text("Deselect All");
			}
			else{
				new_status = false;
				jQuery(this).attr("data-mode","0");
				jQuery(this).text("Select All");
			}
			if(select.length > 0){
				select.find("option").each(function(){
					jQuery(this).attr("selected",new_status);
				});
			}
			if(chkbox.length > 0){
				chkbox.each(function(){
					jQuery(this).attr("checked",new_status);
				});
			}

		});
	});
	if(jQuery('.bp-aus-form') != undefined){
		jQuery('.bp-aus-form').submit(function(e){
			e.preventDefault();
			e.preventBubble=true;
			var erors = 0;

			jQuery(this).find('.required').each(function(){
				var parcol = 'inherit';
				var val = jQuery(this).val();
				if( val == ''){
					erors++;
					parcol = '#FFEBE8';
				}
				jQuery(this).parent().css('background-color',parcol);
			});

			if(erors > 0){
				alert('Please input required fields');
				scroll(0,0);
			}
			else this.submit();
		});


		var animDuration = 600;
		var animEasing = 'swing';
		jQuery('.bp-aus-range-radio').off('click').on('click',function(){
			var name = jQuery(this).attr('name').replace('_range_opt','');
			var val = jQuery(this).val();
			if(val == 'single'){
				jQuery('#'+name.replace(/\[\]$/, '')+'_range_separator').hide(animDuration,animEasing);
				jQuery('#'+name.replace(/\[\]$/, '')+'_range2').hide(animDuration,animEasing);
			}
			else{
				jQuery('#'+name.replace(/\[\]$/, '')+'_range_separator').show(animDuration,animEasing);
				jQuery('#'+name.replace(/\[\]$/, '')+'_range2').show(animDuration,animEasing);
			}
		});

		jQuery('.bp-aus-range-radio').filter(':checked').trigger('click');

		jQuery('.bp-aus-range-reset').off('click').on('click',function(e){
			e.preventDefault();
			var cont = jQuery(this).parent().parent().parent();
			var col = jQuery('.bp-aus-range_inpt',cont);
			col.each(function(ind,elm){
				if(jQuery(elm).is('select')){
					jQuery('option',jQuery(elm)).first().attr('selected',true);
				}
				else if(jQuery(elm).is('input')){
					jQuery(elm).val('');
				}
			});
		});
	}

	jQuery('.bpaus-multifield-container').each(function (){
		var fieldTypes = ['input', 'textarea', 'select'];
		var name, fieldType;
		var $elem = jQuery(this);

		$.each(fieldTypes, function (k, v){
			name = jQuery($elem).find('.editfield').first().find(v).prop('name');

			if (name){
				fieldType = v;

				return false;
			}
		});

		$elem.find('.editfield').each(function (k, v){
			jQuery(this).find(fieldType).attr('id', name.replace(/\[\]$/, '') + '_' + (k + 1));
		});
	});

	jQuery('.bpaus-multifield-container').append('<div class="bpaus-addfield-container"><span class="bpaus-addfield">Add</span></div>');
	jQuery('#wpbody-content > .wrap').find('.bpaus-multifield-container').each(function (){
		jQuery(this).find('.editfield').each(function (k, v){
			if (k){
				jQuery(v).append('<span class="bpaus-removefield">Remove</span>');
			}
		});
	});

	jQuery('.bpaus-multifield-container .bpaus-addfield').on('click', function (){
		var container = jQuery(this).closest('.bpaus-multifield-container');
		var clone = container.find('.editfield').last().clone(true);
		var length = container.find('.editfield').length;
		var fieldTypes = ['input', 'textarea', 'select'];
		var name, fieldType;

		$.each(fieldTypes, function (k, v){
			name = container.find('.editfield').first().find(v).prop('name');

			if (name){
				fieldType = v;

				return false;
			}
		});

		container.find('.editfield').last().after(clone);

		if (length === 1){
			container.find('.editfield').last().append('<span class="bpaus-removefield">Remove</span>');
		}

		container.find('.editfield').last().find(fieldType).attr('id', name.replace(/\[\]$/, '') + '_' + (length + 1));
		container.find('.editfield').last().find(fieldType).val('');

		jQuery('.bpaus-multifield-container .bpaus-removefield').off('click');
		jQuery('.bpaus-multifield-container .bpaus-removefield').on('click', removeField);
	});

	jQuery('.bpaus-multifield-container .bpaus-removefield').on('click', removeField);

	function removeField(){
		var container = jQuery(this).closest('.bpaus-multifield-container');
		var name = container.find('.editfield').first().find('input').prop('name');
		var length = container.find('.editfield').length;
		var fieldTypes = ['input', 'textarea', 'select'];
		var name, fieldType;

		$.each(fieldTypes, function (k, v){
			if (container.find('.editfield').first().find(v).length){
				fieldType = v;

				return false;
			}
		});

		jQuery(this).closest('.editfield').remove();

		container.find('.editfield').each(function (k, v){
			if (k){
				jQuery(v).find(fieldType).attr('id', name + '_' + (k + 1));
			}
		});
	}
});
