<?php
// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) die;

function bp_aus_lite_screentabs_fast_search($displayOptions){
	if(!class_exists( 'BuddyPress' )){
		echo '<div id="message" class="error fade"><p style="line-height: 150%"><strong>Advanced User Search and Reports</strong> requires the BuddyPress plugin to work. Please <a href="http://buddypress.org/download">install BuddyPress</a> first, or <a href="plugins.php">deactivate Advanced User Search and Reports</a>.</p></div>';
	}
	else{
		$txt = '';
		$txt .= bp_aus_lite_screentabs_functions_form_header(
				'',
				array('id' => 'bp_aus_lite_form', 'name' => 'bp_aus_lite_form'),
				array('action' => 'search', 'search-type' => 'fast'),
				'bp-aus-form',
				true
		);
		$counter = 1;
		$txt .= bp_aus_lite_screentabs_functions_form_row( 'bp_aus_lite_search_display', 'On Screen', 'selectbox', false, 'Display Results', $displayOptions , $counter, '', false );
		$counter++;
		$FastSearchVal = '';
		if(isset($_SESSION['bp_advanced_user_search']['phrase'])) $FastSearchVal = $_SESSION['bp_advanced_user_search']['phrase'];
		$txt .= bp_aus_lite_screentabs_functions_form_row( 'bp_aus_lite_fast_search', $FastSearchVal, 'textbox', true, 'Fast Search', '' , $counter );
		$txt .= bp_aus_lite_screentabs_settings_get_buttons('Fast Search','Reset Search Form');
		$txt .= bp_aus_lite_screentabs_functions_upgrade_info();
		echo $txt;
	}
}
?>
