<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) die;

function bp_aus_lite_screentabs_settings_get_showed_fields( $alreadySetup, $name = 'bp_aus_lite_settings_showed_fields', $multiple = 1, $EmptyOptionName = 'Choose' ){
	global $field;
	global $bp;

	if($multiple == 1) $ShowFields = '<select name="'.$name.'[]" id="'.$name.'" multiple="multiple">';
	else{
		$ShowFields = '<select name="'.$name.'" id="'.$name.'">';
		$ShowFields .= '<option value="">'. $EmptyOptionName .'</option>';
	}
	$noOfFields = 0;
	$noOfSelectedFields = 0;
	if (bp_has_profile('hide_empty_fields=0')) while (bp_profile_groups()){
		bp_the_profile_group();
		while (bp_profile_fields()){
			bp_the_profile_field();
			if(is_array($alreadySetup)){
				if(in_array($field->id,$alreadySetup)){
					$noOfSelectedFields++;
					$selected = ' selected="selected"';
				}
				else $selected = '';
			}
			else{
				$selected = ' selected="selected"';
				$noOfSelectedFields++;
			}
			$noOfFields++;
			$ShowFields .= '<option value="'.$field->id.'"'.$selected.'>'.$field->name.'</option>';
		}
	}
	$ShowFields .= '</select>';
	if($multiple == 1){
		if($noOfFields == $noOfSelectedFields) $ShowFields .= '&nbsp;<a href="#" class="bpaus_select_all" data-mode="1">Deselect All</a>';
		else $ShowFields .= '&nbsp;<a href="#" class="bpaus_select_all" data-mode="0">Select All</a>';
	}
	return $ShowFields;
}

function bp_aus_lite_screentabs_settings_get_buttons($saveMessage = 'Save Settings', $resetMessage = 'Reset Settings Form', $includeFormEnd = 1){
	$txt = '
			<p class="bp-aus-center">
				<input type="button" class="button-secondary" onclick="clear_form_elements(this.form)" value="'.translate($resetMessage,'buddypress').'" />
				&nbsp;<span>or</span>&nbsp;
				<input type="submit" class="button-primary" value="'.translate($saveMessage,'buddypress').'" />
			</p>';
	if($includeFormEnd == 1){
		$txt .= '
			</form>
		</div>';
	}
	return $txt;
}

function bp_aus_lite_settings_options(){
	$options = array(
		'max_results_on_page' => array('6','12','18','20','24','30','36','42','50','58','64','76','100'),
		/*'search_type' => array('OR','Range'),//'AND',*/
		'search_behaviour' => array('LIKE %searched value%','LIKE %searched value','LIKE searched value%','= searched value', '<> searched value', '> searched value', '< searched value', '>= searched value', '<= searched value'),
		'search_type' => array('AND', 'OR'),
		'search_type_checkbox' => array('AND', 'OR'),
		'show_mail' => array('0','1'),
		'max_range_fields' => 100
	);
	return $options;
}
?>
